Improve port of AC_C_RESTRICT to Oracle C++
[autoconf.git] / maint.mk
blobc2a9333c5721fa355a6556aa28cb089e605c51aa
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2020 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <https://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
24 # These variables ought to be defined through the configure.ac section
25 # of the module description. But some packages import this file directly,
26 # ignoring the module description.
27 AWK ?= awk
28 GREP ?= grep
29 SED ?= sed
31 # Helper variables.
32 _empty =
33 _sp = $(_empty) $(_empty)
35 # _equal,S1,S2
36 # ------------
37 # If S1 == S2, return S1, otherwise the empty string.
38 _equal = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))
40 # member-check,VARIABLE,VALID-VALUES
41 # ----------------------------------
42 # Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
43 # return it. Die otherwise.
44 member-check = \
45 $(strip \
46 $(if $($(1)), \
47 $(if $(findstring $(_sp),$($(1))), \
48 $(error invalid $(1): '$($(1))', expected $(2)), \
49 $(or $(findstring $(_sp)$($(1))$(_sp),$(_sp)$(2)$(_sp)), \
50 $(error invalid $(1): '$($(1))', expected $(2)))), \
51 $(error $(1) undefined)))
53 # Do not save the original name or timestamp in the .tar.gz file.
54 # Use --rsyncable if available.
55 gzip_rsyncable := \
56 $(shell gzip --help 2>/dev/null|$(GREP) rsyncable >/dev/null \
57 && printf %s --rsyncable)
58 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
60 GIT = git
61 VC = $(GIT)
63 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
65 # You can override this variable in cfg.mk if your gnulib submodule lives
66 # in a different location.
67 gnulib_dir ?= $(srcdir)/gnulib
69 # You can override this variable in cfg.mk to set your own regexp
70 # matching files to ignore.
71 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
73 # This is to preprocess robustly the output of $(VC_LIST), so that even
74 # when $(srcdir) is a pathological name like "....", the leading sed command
75 # removes only the intended prefix.
76 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
78 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
79 # when $(srcdir) is not ".".
80 ifeq ($(srcdir),.)
81 _prepend_srcdir_prefix =
82 else
83 _prepend_srcdir_prefix = | $(SED) 's|^|$(srcdir)/|'
84 endif
86 # In order to be able to consistently filter "."-relative names,
87 # (i.e., with no $(srcdir) prefix), this definition is careful to
88 # remove any $(srcdir) prefix, and to restore what it removes.
89 _sc_excl = \
90 $(or $(exclude_file_name_regexp--$@),^$$)
91 VC_LIST_EXCEPT = \
92 $(VC_LIST) | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
93 | if test -f $(srcdir)/.x-$@; then $(GREP) -vEf $(srcdir)/.x-$@; \
94 else $(GREP) -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
95 | $(GREP) -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
96 $(_prepend_srcdir_prefix)
98 ifeq ($(origin prev_version_file), undefined)
99 prev_version_file = $(srcdir)/.prev-version
100 endif
102 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
103 VERSION_REGEXP = $(subst .,\.,$(VERSION))
104 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
106 ifeq ($(VC),$(GIT))
107 this-vc-tag = v$(VERSION)
108 this-vc-tag-regexp = v$(VERSION_REGEXP)
109 else
110 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
111 tag-this-version = $(subst .,_,$(VERSION))
112 this-vc-tag = $(tag-package)-$(tag-this-version)
113 this-vc-tag-regexp = $(this-vc-tag)
114 endif
115 my_distdir = $(PACKAGE)-$(VERSION)
117 # Old releases are stored here.
118 release_archive_dir ?= ../release
120 # If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
121 # But overwrite VERSION.
122 ifdef RELEASE
123 VERSION := $(word 1, $(RELEASE))
124 RELEASE_TYPE ?= $(word 2, $(RELEASE))
125 endif
127 # Validate and return $(RELEASE_TYPE), or die.
128 RELEASE_TYPES = alpha beta stable
129 release-type = $(call member-check,RELEASE_TYPE,$(RELEASE_TYPES))
131 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
132 # Use alpha.gnu.org for alpha and beta releases.
133 # Use ftp.gnu.org for stable releases.
134 gnu_ftp_host-alpha = alpha.gnu.org
135 gnu_ftp_host-beta = alpha.gnu.org
136 gnu_ftp_host-stable = ftp.gnu.org
137 gnu_rel_host ?= $(gnu_ftp_host-$(release-type))
139 url_dir_list ?= $(if $(call _equal,$(gnu_rel_host),ftp.gnu.org), \
140 https://ftpmirror.gnu.org/$(PACKAGE), \
141 https://$(gnu_rel_host)/gnu/$(PACKAGE))
143 # Override this in cfg.mk if you are using a different format in your
144 # NEWS file.
145 today = $(shell date +%Y-%m-%d)
147 # Select which lines of NEWS are searched for $(news-check-regexp).
148 # This is a sed line number spec. The default says that we search
149 # lines 1..10 of NEWS for $(news-check-regexp).
150 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
151 news-check-lines-spec ?= 1,10
152 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
154 # Prevent programs like 'sort' from considering distinct strings to be equal.
155 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
156 export LC_ALL = C
158 ## --------------- ##
159 ## Sanity checks. ##
160 ## --------------- ##
162 ifneq ($(_gl-Makefile),)
163 _cfg_mk := $(wildcard $(srcdir)/cfg.mk)
165 # Collect the names of rules starting with 'sc_'.
166 syntax-check-rules := $(sort $(shell $(SED) -n \
167 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(srcdir)/$(ME) $(_cfg_mk)))
168 .PHONY: $(syntax-check-rules)
170 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
171 local-checks-available += $(syntax-check-rules)
172 else
173 local-checks-available += no-vc-detected
174 no-vc-detected:
175 @echo "No version control files detected; skipping syntax check"
176 endif
177 .PHONY: $(local-checks-available)
179 # Arrange to print the name of each syntax-checking rule just before running it.
180 $(syntax-check-rules): %: %.m
181 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
182 .PHONY: $(sc_m_rules_)
183 $(sc_m_rules_):
184 @echo $(patsubst sc_%.m, %, $@)
185 @date +%s.%N > .sc-start-$(basename $@)
187 # Compute and print the elapsed time for each syntax-check rule.
188 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
189 .PHONY: $(sc_z_rules_)
190 $(sc_z_rules_): %.z: %
191 @end=$$(date +%s.%N); \
192 start=$$(cat .sc-start-$*); \
193 rm -f .sc-start-$*; \
194 $(AWK) -v s=$$start -v e=$$end \
195 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
197 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
198 # that computes and prints elapsed time.
199 local-check := \
200 $(patsubst sc_%, sc_%.z, \
201 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
203 syntax-check: $(local-check)
204 endif
206 # _sc_search_regexp
208 # This macro searches for a given construct in the selected files and
209 # then takes some action.
211 # Parameters (shell variables):
213 # prohibit | require
215 # Regular expression (ERE) denoting either a forbidden construct
216 # or a required construct. Those arguments are exclusive.
218 # exclude
220 # Regular expression (ERE) denoting lines to ignore that matched
221 # a prohibit construct. For example, this can be used to exclude
222 # comments that mention why the nearby code uses an alternative
223 # construct instead of the simpler prohibited construct.
225 # in_vc_files | in_files
227 # grep-E-style regexp selecting the files to check. For in_vc_files,
228 # the regexp is used to select matching files from the list of all
229 # version-controlled files; for in_files, it's from the names printed
230 # by "find $(srcdir)". When neither is specified, use all files that
231 # are under version control.
233 # containing | non_containing
235 # Select the files (non) containing strings matching this regexp.
236 # If both arguments are specified then CONTAINING takes
237 # precedence.
239 # with_grep_options
241 # Extra options for grep.
243 # ignore_case
245 # Ignore case.
247 # halt
249 # Message to display before to halting execution.
251 # Finally, you may exempt files based on an ERE matching file names.
252 # For example, to exempt from the sc_space_tab check all files with the
253 # .diff suffix, set this Make variable:
255 # exclude_file_name_regexp--sc_space_tab = \.diff$
257 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
258 # when filtering by name via in_files, we explicitly filter out matching
259 # names here as well.
261 # Initialize each, so that envvar settings cannot interfere.
262 export require =
263 export prohibit =
264 export exclude =
265 export in_vc_files =
266 export in_files =
267 export containing =
268 export non_containing =
269 export halt =
270 export with_grep_options =
272 # By default, _sc_search_regexp does not ignore case.
273 export ignore_case =
274 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
276 define _sc_say_and_exit
277 dummy=; : so we do not need a semicolon before each use; \
278 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
279 endef
281 define _sc_search_regexp
282 dummy=; : so we do not need a semicolon before each use; \
284 : Check arguments; \
285 test -n "$$prohibit" && test -n "$$require" \
286 && { msg='Cannot specify both prohibit and require' \
287 $(_sc_say_and_exit) } || :; \
288 test -z "$$prohibit" && test -z "$$require" \
289 && { msg='Should specify either prohibit or require' \
290 $(_sc_say_and_exit) } || :; \
291 test -z "$$prohibit" && test -n "$$exclude" \
292 && { msg='Use of exclude requires a prohibit pattern' \
293 $(_sc_say_and_exit) } || :; \
294 test -n "$$in_vc_files" && test -n "$$in_files" \
295 && { msg='Cannot specify both in_vc_files and in_files' \
296 $(_sc_say_and_exit) } || :; \
297 test "x$$halt" != x \
298 || { msg='halt not defined' $(_sc_say_and_exit) }; \
300 : Filter by file name; \
301 if test -n "$$in_files"; then \
302 files=$$(find $(srcdir) | $(GREP) -E "$$in_files" \
303 | $(GREP) -Ev '$(_sc_excl)'); \
304 else \
305 files=$$($(VC_LIST_EXCEPT)); \
306 if test -n "$$in_vc_files"; then \
307 files=$$(echo "$$files" | $(GREP) -E "$$in_vc_files"); \
308 fi; \
309 fi; \
311 : Filter by content; \
312 test -n "$$files" \
313 && test -n "$$containing" \
314 && { files=$$(echo "$$files" | xargs $(GREP) -l "$$containing"); } \
315 || :; \
316 test -n "$$files" \
317 && test -n "$$non_containing" \
318 && { files=$$(echo "$$files" | xargs $(GREP) -vl "$$non_containing"); } \
319 || :; \
321 : Check for the construct; \
322 if test -n "$$files"; then \
323 if test -n "$$prohibit"; then \
324 echo "$$files" \
325 | xargs $(GREP) $$with_grep_options $(_ignore_case) -nE \
326 "$$prohibit" /dev/null \
327 | $(GREP) -vE "$${exclude:-^$$}" \
328 && { msg="$$halt" $(_sc_say_and_exit) } \
329 || :; \
330 else \
331 echo "$$files" \
332 | xargs \
333 $(GREP) $$with_grep_options $(_ignore_case) -LE "$$require" \
334 | $(GREP) . \
335 && { msg="$$halt" $(_sc_say_and_exit) } \
336 || :; \
337 fi \
338 else :; \
339 fi || :;
340 endef
342 sc_avoid_if_before_free:
343 @$(VC_LIST_EXCEPT) \
344 | $(GREP) -v useless-if-before-free \
345 | xargs \
346 $(srcdir)/$(_build-aux)/useless-if-before-free \
347 $(useless_free_options) \
348 && { printf '$(ME): found useless "if"' \
349 ' before "free" above\n' 1>&2; \
350 exit 1; } \
351 || :
353 sc_cast_of_argument_to_free:
354 @prohibit='\<free *\( *\(' halt="don't cast free argument" \
355 $(_sc_search_regexp)
357 sc_cast_of_x_alloc_return_value:
358 @prohibit='\*\) *x(m|c|re)alloc\>' \
359 halt="don't cast x*alloc return value" \
360 $(_sc_search_regexp)
362 sc_cast_of_alloca_return_value:
363 @prohibit='\*\) *alloca\>' \
364 halt="don't cast alloca return value" \
365 $(_sc_search_regexp)
367 sc_space_tab:
368 @prohibit='[ ] ' \
369 halt='found SPACE-TAB sequence; remove the SPACE' \
370 $(_sc_search_regexp)
372 # Don't use *scanf or the old ato* functions in "real" code.
373 # They provide no error checking mechanism.
374 # Instead, use strto* functions.
375 sc_prohibit_atoi_atof:
376 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
377 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
378 $(_sc_search_regexp)
380 # Use STREQ rather than comparing strcmp == 0, or != 0.
381 sp_ = strcmp *\(.+\)
382 sc_prohibit_strcmp:
383 @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
384 exclude='# *define STRN?EQ\(' \
385 halt='replace strcmp calls above with STREQ/STRNEQ' \
386 $(_sc_search_regexp)
388 # Really. You don't want to use this function.
389 # It may fail to NUL-terminate the destination,
390 # and always NUL-pads out to the specified length.
391 sc_prohibit_strncpy:
392 @prohibit='\<strncpy *\(' \
393 halt='do not use strncpy, period' \
394 $(_sc_search_regexp)
396 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
397 # Convert all uses automatically, via these two commands:
398 # git grep -l '\<exit *(1)' \
399 # | grep -vEf .x-sc_prohibit_magic_number_exit \
400 # | xargs --no-run-if-empty \
401 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
402 # git grep -l '\<exit *(0)' \
403 # | grep -vEf .x-sc_prohibit_magic_number_exit \
404 # | xargs --no-run-if-empty \
405 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
406 sc_prohibit_magic_number_exit:
407 @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]' \
408 exclude='exit \(77\)|error ?\(((0|77),|[^,]*)' \
409 halt='use EXIT_* values rather than magic number' \
410 $(_sc_search_regexp)
412 # Check that we don't use $< in non-implicit Makefile rules.
414 # To find the Makefiles, trace AC_CONFIG_FILES. Using VC_LIST would
415 # miss the Makefiles that are not under VC control (e.g., symlinks
416 # installed for gettext). "Parsing" (recursive) uses of SUBDIRS seems
417 # too delicate.
419 # Use GNU Make's --print-data-base to normalize the rules into some
420 # easy to parse format: they are separated by two \n. Look for the
421 # "section" about non-pattern rules (marked with "# Files") inside
422 # which there are still the POSIX Make like implicit rules (".c.o").
423 sc_prohibit_gnu_make_extensions_awk_ = \
424 BEGIN { \
425 RS = "\n\n"; \
426 in_rules = 0; \
428 /^\# Files/ { \
429 in_rules = 1; \
431 /\$$</ && in_rules && $$0 !~ /^(.*\n)*\.\w+(\.\w+)?:/ { \
432 print "Error: " file ": $$< in a non implicit rule\n" $$0; \
433 status = 1; \
435 END { \
436 exit status; \
438 sc_prohibit_gnu_make_extensions:
439 @if $(AWK) --version | grep GNU >/dev/null 2>&1; then \
440 (cd $(srcdir) && autoconf --trace AC_CONFIG_FILES:'$$1') | \
441 tr ' ' '\n' | \
442 $(SED) -ne '/Makefile/{s/\.in$$//;p;}' | \
443 while read m; do \
444 $(MAKE) -qp -f $$m .DUMMY-TARGET 2>/dev/null | \
445 $(AWK) -v file=$$m -e '$($@_awk_)' || exit 1; \
446 done; \
449 # Using EXIT_SUCCESS as the first argument to error is misleading,
450 # since when that parameter is 0, error does not exit. Use '0' instead.
451 sc_error_exit_success:
452 @prohibit='error *\(EXIT_SUCCESS,' \
453 in_vc_files='\.[chly]$$' \
454 halt='found error (EXIT_SUCCESS' \
455 $(_sc_search_regexp)
457 # "FATAL:" should be fully upper-cased in error messages
458 # "WARNING:" should be fully upper-cased, or fully lower-cased
459 sc_error_message_warn_fatal:
460 @$(VC_LIST_EXCEPT) \
461 | xargs $(GREP) -nEA2 '[^rp]error *\(' /dev/null \
462 | $(GREP) -E '"Warning|"Fatal|"fatal' \
463 && { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
464 exit 1; } \
465 || :
467 # Error messages should not start with a capital letter;
468 # however, if they start with an entire fully uppercased word, that's
469 # probably a proper noun and it should stay that way. We also exempt
470 # known instances of proper nouns that should stay mixed-case.
471 sc_error_message_uppercase:
472 @$(VC_LIST_EXCEPT) \
473 | xargs $(GREP) -nEA2 '[^rp]error *\(' /dev/null \
474 | $(GREP) -E '"[A-Z]' \
475 | $(GREP) -vE '"([A-Z0-9_]{2,}\>|Java|C#|(PRI|SCN)[dioux])' \
476 && { echo '$(ME): found capitalized error message' 1>&2; \
477 exit 1; } \
478 || :
480 # Error messages should not end with a period
481 sc_error_message_period:
482 @$(VC_LIST_EXCEPT) \
483 | xargs $(GREP) -nEA2 '[^rp]error *\(' /dev/null \
484 | $(GREP) -E '[^."]\."' \
485 && { echo '$(ME): found error message ending in period' 1>&2; \
486 exit 1; } \
487 || :
489 sc_file_system:
490 @prohibit=file''system \
491 exclude='/proc/filesystems' \
492 ignore_case=1 \
493 halt='found use of "file''system"; spell it "file system"' \
494 $(_sc_search_regexp)
496 # Don't use cpp tests of this symbol. All code assumes config.h is included.
497 sc_prohibit_have_config_h:
498 @prohibit='^# *if.*HAVE''_CONFIG_H' \
499 halt='found use of HAVE''_CONFIG_H; remove' \
500 $(_sc_search_regexp)
502 # Nearly all .c files must include <config.h>. However, we also permit this
503 # via inclusion of a package-specific header, if cfg.mk specified one.
504 # config_h_header must be suitable for grep -E.
505 config_h_header ?= <config\.h>
506 sc_require_config_h:
507 @require='^# *include $(config_h_header)' \
508 in_vc_files='\.c$$' \
509 halt='the above files do not include <config.h>' \
510 $(_sc_search_regexp)
512 # Print each file name for which the first #include does not match
513 # $(config_h_header). Like grep -m 1, this only looks at the first match.
514 perl_config_h_first_ = \
515 -e 'BEGIN {$$ret = 0}' \
516 -e 'if (/^\# *include\b/) {' \
517 -e ' if (not m{^\# *include $(config_h_header)}) {' \
518 -e ' print "$$ARGV\n";' \
519 -e ' $$ret = 1;' \
520 -e ' }' \
521 -e ' \# Move on to next file after first include' \
522 -e ' close ARGV;' \
523 -e '}' \
524 -e 'END {exit $$ret}'
526 # You must include <config.h> before including any other header file.
527 # This can possibly be via a package-specific header, if given by cfg.mk.
528 sc_require_config_h_first:
529 @if $(VC_LIST_EXCEPT) | $(GREP) '\.c$$' > /dev/null; then \
530 files=$$($(VC_LIST_EXCEPT) | $(GREP) '\.c$$') && \
531 perl -n $(perl_config_h_first_) $$files || \
532 { echo '$(ME): the above files include some other header' \
533 'before <config.h>' 1>&2; exit 1; } || :; \
534 else :; \
537 sc_prohibit_HAVE_MBRTOWC:
538 @prohibit='\bHAVE_MBRTOWC\b' \
539 halt="do not use $$prohibit; it is always defined" \
540 $(_sc_search_regexp)
542 # To use this "command" macro, you must first define two shell variables:
543 # h: the header name, with no enclosing <> or ""
544 # re: a regular expression that matches IFF something provided by $h is used.
545 define _sc_header_without_use
546 dummy=; : so we do not need a semicolon before each use; \
547 h_esc=`echo '[<"]'"$$h"'[">]'|$(SED) 's/\./\\\\./g'`; \
548 if $(VC_LIST_EXCEPT) | $(GREP) '\.c$$' > /dev/null; then \
549 files=$$($(GREP) -l '^# *include '"$$h_esc" \
550 $$($(VC_LIST_EXCEPT) | $(GREP) '\.c$$')) && \
551 $(GREP) -LE "$$re" $$files | $(GREP) . && \
552 { echo "$(ME): the above files include $$h but don't use it" \
553 1>&2; exit 1; } || :; \
554 else :; \
556 endef
558 # Prohibit the inclusion of assert.h without an actual use of assert.
559 sc_prohibit_assert_without_use:
560 @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
562 # Prohibit the inclusion of close-stream.h without an actual use.
563 sc_prohibit_close_stream_without_use:
564 @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
566 # Prohibit the inclusion of getopt.h without an actual use.
567 sc_prohibit_getopt_without_use:
568 @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
570 # Don't include quotearg.h unless you use one of its functions.
571 sc_prohibit_quotearg_without_use:
572 @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
574 # Don't include quote.h unless you use one of its functions.
575 sc_prohibit_quote_without_use:
576 @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
577 $(_sc_header_without_use)
579 # Don't include this header unless you use one of its functions.
580 sc_prohibit_long_options_without_use:
581 @h='long-options.h' re='\<parse_(long_options|gnu_standard_options_only) *\(' \
582 $(_sc_header_without_use)
584 # Don't include this header unless you use one of its functions.
585 sc_prohibit_inttostr_without_use:
586 @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
587 $(_sc_header_without_use)
589 # Don't include this header unless you use one of its functions.
590 sc_prohibit_ignore_value_without_use:
591 @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
592 $(_sc_header_without_use)
594 # Don't include this header unless you use one of its functions.
595 sc_prohibit_error_without_use:
596 @h='error.h' \
597 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
598 $(_sc_header_without_use)
600 # Don't include xalloc.h unless you use one of its functions.
601 # Consider these symbols:
602 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
603 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
604 # Divide into two sets on case, and filter each through this:
605 # | sort | perl -MRegexp::Assemble -le \
606 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
607 # Note this was produced by the above:
608 # _xa1 = \
609 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
610 # But we can do better, in at least two ways:
611 # 1) take advantage of two "dup"-suffixed strings:
612 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
613 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
614 # "char|[cmz]"
615 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
616 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
617 _xa2 = X([CZ]|N?M)ALLOC
618 sc_prohibit_xalloc_without_use:
619 @h='xalloc.h' \
620 re='\<($(_xa1)|$(_xa2)) *\('\
621 $(_sc_header_without_use)
623 # Extract function names:
624 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
625 _hash_re = \
626 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
627 _hash_fn = \<($(_hash_re)) *\(
628 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
629 sc_prohibit_hash_without_use:
630 @h='hash.h' \
631 re='$(_hash_fn)|$(_hash_struct)'\
632 $(_sc_header_without_use)
634 sc_prohibit_cloexec_without_use:
635 @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
636 $(_sc_header_without_use)
638 sc_prohibit_posixver_without_use:
639 @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
641 sc_prohibit_same_without_use:
642 @h='same.h' re='\<same_name(at)? *\(' $(_sc_header_without_use)
644 sc_prohibit_hash_pjw_without_use:
645 @h='hash-pjw.h' \
646 re='\<hash_pjw\>' \
647 $(_sc_header_without_use)
649 sc_prohibit_safe_read_without_use:
650 @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
651 $(_sc_header_without_use)
653 sc_prohibit_argmatch_without_use:
654 @h='argmatch.h' \
655 re='(\<(ARGMATCH_DEFINE_GROUP|ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
656 $(_sc_header_without_use)
658 sc_prohibit_canonicalize_without_use:
659 @h='canonicalize.h' \
660 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
661 $(_sc_header_without_use)
663 sc_prohibit_root_dev_ino_without_use:
664 @h='root-dev-ino.h' \
665 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
666 $(_sc_header_without_use)
668 sc_prohibit_openat_without_use:
669 @h='openat.h' \
670 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat|(FCHMOD|FCHOWN|STAT)AT_INLINE)\>' \
671 $(_sc_header_without_use)
673 # Prohibit the inclusion of c-ctype.h without an actual use.
674 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
675 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
676 sc_prohibit_c_ctype_without_use:
677 @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
678 $(_sc_header_without_use)
680 # The following list was generated by running:
681 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
682 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
683 _sig_functions = \
684 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
685 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
686 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
687 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
688 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
689 # The following were extracted from "man signal.h" manually.
690 _sig_types_and_consts = \
691 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
692 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
693 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
694 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
695 sigstack sigval stack_t ucontext_t
696 # generated via this:
697 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
698 _sig_names = \
699 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
700 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
701 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
702 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
703 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
704 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
705 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
706 SIGXCPU SIGXFSZ
707 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
709 # Prohibit the inclusion of signal.h without an actual use.
710 sc_prohibit_signal_without_use:
711 @h='signal.h' \
712 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
713 $(_sc_header_without_use)
715 # Don't include stdio--.h unless you use one of its functions.
716 sc_prohibit_stdio--_without_use:
717 @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
718 $(_sc_header_without_use)
720 # Don't include stdio-safer.h unless you use one of its functions.
721 sc_prohibit_stdio-safer_without_use:
722 @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
723 $(_sc_header_without_use)
725 # Prohibit the inclusion of strings.h without a sensible use.
726 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
727 sc_prohibit_strings_without_use:
728 @h='strings.h' \
729 re='\<(strn?casecmp|ffs(ll)?)\>' \
730 $(_sc_header_without_use)
732 # Extract the raw list of symbol names with this:
733 gl_extract_define_simple = \
734 /^\# *define ([A-Z]\w+)\(/ and print $$1
735 # Filter out duplicates and convert to a space-separated list:
736 _intprops_names = \
737 $(shell f=$(gnulib_dir)/lib/intprops.h; \
738 perl -lne '$(gl_extract_define_simple)' $$f | sort -u | tr '\n' ' ')
739 # Remove trailing space and convert to a regular expression:
740 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
741 # Prohibit the inclusion of intprops.h without an actual use.
742 sc_prohibit_intprops_without_use:
743 @h='intprops.h' \
744 re='\<($(_intprops_syms_re)) *\(' \
745 $(_sc_header_without_use)
747 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
748 # Prohibit the inclusion of stddef.h without an actual use.
749 sc_prohibit_stddef_without_use:
750 @h='stddef.h' \
751 re='\<($(_stddef_syms_re))\>' \
752 $(_sc_header_without_use)
754 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
755 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
756 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
757 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
758 # Prohibit the inclusion of dirent.h without an actual use.
759 sc_prohibit_dirent_without_use:
760 @h='dirent.h' \
761 re='\<($(_dirent_syms_re))\>' \
762 $(_sc_header_without_use)
764 # Prohibit the inclusion of verify.h without an actual use.
765 sc_prohibit_verify_without_use:
766 @h='verify.h' \
767 re='\<(verify(true|expr)?|assume|static_assert) *\(' \
768 $(_sc_header_without_use)
770 # Don't include xfreopen.h unless you use one of its functions.
771 sc_prohibit_xfreopen_without_use:
772 @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
774 sc_obsolete_symbols:
775 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
776 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
777 $(_sc_search_regexp)
779 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
781 # Each nonempty ChangeLog line must start with a year number, or a TAB.
782 sc_changelog:
783 @prohibit='^[^12 ]' \
784 in_vc_files='^ChangeLog$$' \
785 halt='found unexpected prefix in a ChangeLog' \
786 $(_sc_search_regexp)
788 # Ensure that each .c file containing a "main" function also
789 # calls bindtextdomain.
790 sc_bindtextdomain:
791 @require='bindtextdomain *\(' \
792 in_vc_files='\.c$$' \
793 containing='\<main *(' \
794 halt='the above files do not call bindtextdomain' \
795 $(_sc_search_regexp)
797 # Require that the final line of each test-lib.sh-using test be this one:
798 # Exit $fail
799 # Note: this test requires GNU grep's --label= option.
800 Exit_witness_file ?= tests/test-lib.sh
801 Exit_base := $(notdir $(Exit_witness_file))
802 sc_require_test_exit_idiom:
803 @if test -f $(srcdir)/$(Exit_witness_file); then \
804 die=0; \
805 for i in $$($(GREP) -l -F 'srcdir/$(Exit_base)' \
806 $$($(VC_LIST) tests)); do \
807 tail -n1 $$i | $(GREP) '^Exit .' > /dev/null \
808 && : || { die=1; echo $$i; } \
809 done; \
810 test $$die = 1 && \
811 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
812 echo 1>&2 'Exit something'; \
813 exit 1; } || :; \
816 sc_trailing_blank:
817 @prohibit='[ ]$$' \
818 halt='found trailing blank(s)' \
819 exclude='^Binary file .* matches$$' \
820 $(_sc_search_regexp)
822 # Match lines like the following, but where there is only one space
823 # between the options and the description:
824 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
825 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
826 sc_two_space_separator_in_usage:
827 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
828 halt='help2man requires at least two spaces between an option and its description'\
829 $(_sc_search_regexp)
831 # A regexp matching function names like "error" that may be used
832 # to emit translatable messages.
833 _gl_translatable_diag_func_re ?= error
835 # Look for diagnostics that aren't marked for translation.
836 # This won't find any for which error's format string is on a separate line.
837 sc_unmarked_diagnostics:
838 @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
839 exclude='(_|ngettext ?)\(' \
840 halt='found unmarked diagnostic(s)' \
841 $(_sc_search_regexp)
843 # Avoid useless parentheses like those in this example:
844 # #if defined (SYMBOL) || defined (SYM2)
845 sc_useless_cpp_parens:
846 @prohibit='^# *if .*defined *\(' \
847 halt='found useless parentheses in cpp directive' \
848 $(_sc_search_regexp)
850 # List headers for which HAVE_HEADER_H is always true, assuming you are
851 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
852 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
853 # requires the gnulib module that guarantees the usability of that header.
854 gl_assured_headers_ = \
855 cd $(gnulib_dir)/lib && echo *.in.h|$(SED) 's/\.in\.h//g'
857 # Convert the list of names to upper case, and replace each space with "|".
858 az_ = abcdefghijklmnopqrstuvwxyz
859 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
860 gl_header_upper_case_or_ = \
861 $$($(gl_assured_headers_) \
862 | tr $(az_)/.- $(AZ_)___ \
863 | tr -s ' ' '|' \
865 sc_prohibit_always_true_header_tests:
866 @or=$(gl_header_upper_case_or_); \
867 re="HAVE_($$or)_H"; \
868 prohibit='\<'"$$re"'\>' \
869 halt=$$(printf '%s\n' \
870 'do not test the above HAVE_<header>_H symbol(s);' \
871 ' with the corresponding gnulib module, they are always true') \
872 $(_sc_search_regexp)
874 sc_prohibit_defined_have_decl_tests:
875 @prohibit='(#[ ]*ifn?def|\<defined)\>[ (]+HAVE_DECL_' \
876 halt='HAVE_DECL macros are always defined' \
877 $(_sc_search_regexp)
879 # ==================================================================
880 gl_other_headers_ ?= \
881 intprops.h \
882 openat.h \
883 stat-macros.h
885 # Perl -lne code to extract "significant" cpp-defined symbols from a
886 # gnulib header file, eliminating a few common false-positives.
887 # The exempted names below are defined only conditionally in gnulib,
888 # and hence sometimes must/may be defined in application code.
889 gl_extract_significant_defines_ = \
890 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
891 && $$2 !~ /(?:rpl_|_used_without_)/\
892 && $$1 !~ /^(?:NSIG|ENODATA)$$/\
893 && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
894 and print $$1
896 # Create a list of regular expressions matching the names
897 # of macros that are guaranteed to be defined by parts of gnulib.
898 define def_sym_regex
899 gen_h=$(gl_generated_headers_); \
900 (cd $(gnulib_dir)/lib; \
901 for f in *.in.h $(gl_other_headers_); do \
902 test -f $$f \
903 && perl -lne '$(gl_extract_significant_defines_)' $$f; \
904 done; \
905 ) | sort -u \
906 | $(SED) 's/^/^ *# *(define|undef) */;s/$$/\\>/'
907 endef
909 # Don't define macros that we already get from gnulib header files.
910 sc_prohibit_always-defined_macros:
911 @if test -d $(gnulib_dir); then \
912 case $$(echo all: | $(GREP) -l -f - Makefile) in Makefile);; *) \
913 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
914 esac; \
915 regex=$$($(def_sym_regex)); export regex; \
916 $(VC_LIST_EXCEPT) \
917 | xargs sh -c 'echo $$regex | $(GREP) -E -f - "$$@"' \
918 dummy /dev/null \
919 && { printf '$(ME): define the above' \
920 ' via some gnulib .h file\n' 1>&2; \
921 exit 1; } \
922 || :; \
924 # ==================================================================
926 # Prohibit checked in backup files.
927 sc_prohibit_backup_files:
928 @$(VC_LIST) | $(GREP) '~$$' && \
929 { echo '$(ME): found version controlled backup file' 1>&2; \
930 exit 1; } || :
932 # Require the latest GPL.
933 sc_GPL_version:
934 @prohibit='either ''version [^3]' \
935 halt='GPL vN, N!=3' \
936 $(_sc_search_regexp)
938 # Require the latest GFDL. Two regexp, since some .texi files end up
939 # line wrapping between 'Free Documentation License,' and 'Version'.
940 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
941 sc_GFDL_version:
942 @prohibit='$(_GFDL_regexp)' \
943 halt='GFDL vN, N!=3' \
944 $(_sc_search_regexp)
946 # Don't use Texinfo's @acronym{}.
947 # https://lists.gnu.org/r/bug-gnulib/2010-03/msg00321.html
948 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
949 sc_texinfo_acronym:
950 @prohibit='@acronym\{' \
951 in_vc_files='$(texinfo_suffix_re_)' \
952 halt='found use of Texinfo @acronym{}' \
953 $(_sc_search_regexp)
955 cvs_keywords = \
956 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
958 sc_prohibit_cvs_keyword:
959 @prohibit='\$$($(cvs_keywords))\$$' \
960 halt='do not use CVS keyword expansion' \
961 $(_sc_search_regexp)
963 # This Perl code is slightly obfuscated. Not only is each "$" doubled
964 # because it's in a Makefile, but the $$c's are comments; we cannot
965 # use "#" due to the way the script ends up concatenated onto one line.
966 # It would be much more concise, and would produce better output (including
967 # counts) if written as:
968 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
969 # but that would be far less efficient, reading the entire contents
970 # of each file, rather than just the last two bytes of each.
971 # In addition, while the code below detects both blank lines and a missing
972 # newline at EOF, the above detects only the former.
974 # This is a perl script that is expected to be the single-quoted argument
975 # to a command-line "-le". The remaining arguments are file names.
976 # Print the name of each file that does not end in exactly one newline byte.
977 # I.e., warn if there are blank lines (2 or more newlines), or if the
978 # last byte is not a newline. However, currently we don't complain
979 # about any file that contains exactly one byte.
980 # Exit nonzero if at least one such file is found, otherwise, exit 0.
981 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
983 # Use this if you want to remove trailing empty lines from selected files:
984 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
986 require_exactly_one_NL_at_EOF_ = \
987 foreach my $$f (@ARGV) \
989 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
990 my $$p = sysseek (F, -2, 2); \
991 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
992 my $$last_two_bytes; \
993 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
994 close F; \
995 $$c = "ignore read failure"; \
996 $$p && ($$last_two_bytes eq "\n\n" \
997 || substr ($$last_two_bytes,1) ne "\n") \
998 and (print $$f), $$fail=1; \
1000 END { exit defined $$fail }
1001 sc_prohibit_empty_lines_at_EOF:
1002 @$(VC_LIST_EXCEPT) \
1003 | xargs perl -le '$(require_exactly_one_NL_at_EOF_)' \
1004 || { echo '$(ME): empty line(s) or no newline at EOF' 1>&2; \
1005 exit 1; } \
1006 || :
1008 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
1009 # This is a bit of a kludge, since it prevents use of the string
1010 # even in comments, but for now it does the job with no false positives.
1011 sc_prohibit_stat_st_blocks:
1012 @prohibit='[.>]st_blocks' \
1013 halt='do not use st_blocks; use ST_NBLOCKS' \
1014 $(_sc_search_regexp)
1016 # Make sure we don't define any S_IS* macros in src/*.c files.
1017 # They're already defined via gnulib's sys/stat.h replacement.
1018 sc_prohibit_S_IS_definition:
1019 @prohibit='^ *# *define *S_IS' \
1020 halt='do not define S_IS* macros; include <sys/stat.h>' \
1021 $(_sc_search_regexp)
1023 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
1024 # that is shared by two definitions below.
1025 perl_filename_lineno_text_ = \
1026 -e ' {' \
1027 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
1028 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
1029 -e ' print "$$ARGV:$$n:$$v\n";' \
1030 -e ' }'
1032 prohibit_doubled_words_ = \
1033 the then in an on if is it but for or at and do to
1034 # expand the regex before running the check to avoid using expensive captures
1035 prohibit_doubled_word_expanded_ = \
1036 $(join $(prohibit_doubled_words_),$(addprefix \s+,$(prohibit_doubled_words_)))
1037 prohibit_doubled_word_RE_ ?= \
1038 /\b(?:$(subst $(_sp),|,$(prohibit_doubled_word_expanded_)))\b/gims
1039 prohibit_doubled_word_ = \
1040 -e 'while ($(prohibit_doubled_word_RE_))' \
1041 $(perl_filename_lineno_text_)
1043 # Define this to a regular expression that matches
1044 # any filename:dd:match lines you want to ignore.
1045 # The default is to ignore no matches.
1046 ignore_doubled_word_match_RE_ ?= ^$$
1048 sc_prohibit_doubled_word:
1049 @$(VC_LIST_EXCEPT) \
1050 | xargs perl -n -0777 $(prohibit_doubled_word_) \
1051 | $(GREP) -vE '$(ignore_doubled_word_match_RE_)' \
1052 | $(GREP) . \
1053 && { echo '$(ME): doubled words' 1>&2; exit 1; } \
1054 || :
1056 # A regular expression matching undesirable combinations of words like
1057 # "can not"; this matches them even when the two words appear on different
1058 # lines, but not when there is an intervening delimiter like "#" or "*".
1059 # Similarly undesirable, "See @xref{...}", since an @xref should start
1060 # a sentence. Explicitly prohibit any prefix of "see" or "also".
1061 # Also prohibit a prefix matching "\w+ +".
1062 # @pxref gets the same see/also treatment and should be parenthesized;
1063 # presume it must *not* start a sentence.
1064 # POSIX spells it "timestamp" rather than "time\s+stamp", so we do, too.
1065 bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
1066 bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
1067 prohibit_undesirable_word_seq_RE_ ?= \
1068 /(?:\bcan\s+not\b|\btime\s+stamps?\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
1069 prohibit_undesirable_word_seq_ = \
1070 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
1071 $(perl_filename_lineno_text_)
1072 # Define this to a regular expression that matches
1073 # any filename:dd:match lines you want to ignore.
1074 # The default is to ignore no matches.
1075 ignore_undesirable_word_sequence_RE_ ?= ^$$
1077 sc_prohibit_undesirable_word_seq:
1078 @$(VC_LIST_EXCEPT) \
1079 | xargs perl -n -0777 $(prohibit_undesirable_word_seq_) \
1080 | $(GREP) -vE '$(ignore_undesirable_word_sequence_RE_)' \
1081 | $(GREP) . \
1082 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } \
1083 || :
1085 # Except for shell files and for loops, double semicolon is probably a mistake
1086 sc_prohibit_double_semicolon:
1087 @prohibit='; *;[ {} \]*(/[/*]|$$)' \
1088 in_vc_files='\.[chly]$$' \
1089 exclude='\bfor *\(.*\)' \
1090 halt="Double semicolon detected" \
1091 $(_sc_search_regexp)
1093 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
1094 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
1095 # Using test's -a and -o operators is not portable.
1096 # We prefer test over [, since the latter is spelled [[ in configure.ac.
1097 sc_prohibit_test_minus_ao:
1098 @prohibit='(\<test| \[+) .+ -[ao] ' \
1099 halt='$(_ptm1); $(_ptm2)' \
1100 $(_sc_search_regexp)
1102 # Avoid a test bashism.
1103 sc_prohibit_test_double_equal:
1104 @prohibit='(\<test| \[+) .+ == ' \
1105 containing='#! */bin/[a-z]*sh' \
1106 halt='use "test x = x", not "test x =''= x"' \
1107 $(_sc_search_regexp)
1109 # Each program that uses proper_name_utf8 must link with one of the
1110 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
1111 # The perl -0777 invocation below extracts the possibly-multi-line
1112 # definition of LDADD from the appropriate Makefile.am and exits 0
1113 # when it contains "ICONV".
1114 sc_proper_name_utf8_requires_ICONV:
1115 @progs=$$($(VC_LIST_EXCEPT) \
1116 | xargs $(GREP) -l 'proper_name_utf8 ''("'); \
1117 if test "x$$progs" != x; then \
1118 fail=0; \
1119 for p in $$progs; do \
1120 dir=$$(dirname "$$p"); \
1121 perl -0777 \
1122 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
1123 $$dir/Makefile.am && continue; \
1124 base=$$(basename "$$p" .c); \
1125 $(GREP) "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1126 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1127 done; \
1128 test $$fail = 1 && \
1129 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1130 exit 1; } || :; \
1133 # Warn about "c0nst struct Foo const foo[]",
1134 # but not about "char const *const foo" or "#define const const".
1135 sc_redundant_const:
1136 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
1137 halt='redundant "const" in declarations' \
1138 $(_sc_search_regexp)
1140 sc_const_long_option:
1141 @prohibit='^ *static.*struct option ' \
1142 exclude='const struct option|struct option const' \
1143 halt='add "const" to the above declarations' \
1144 $(_sc_search_regexp)
1146 NEWS_hash = \
1147 $$($(SED) -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
1148 $(srcdir)/NEWS \
1149 | perl -0777 -pe \
1150 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
1151 | md5sum - \
1152 | $(SED) 's/ .*//')
1154 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1155 sc_immutable_NEWS:
1156 @if test -f $(srcdir)/NEWS; then \
1157 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
1158 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1161 # Update the hash stored above. Do this after each release and
1162 # for any corrections to old entries.
1163 update-NEWS-hash: NEWS
1164 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1165 $(srcdir)/cfg.mk
1167 # Ensure that we use only the standard $(VAR) notation,
1168 # not @...@ in Makefile.am, now that we can rely on automake
1169 # to emit a definition for each substituted variable.
1170 # However, there is still one case in which @VAR@ use is not just
1171 # legitimate, but actually required: when augmenting an automake-defined
1172 # variable with a prefix. For example, gettext uses this:
1173 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1174 # otherwise, makeinfo would put German or French (current locale)
1175 # navigation hints in the otherwise-English documentation.
1177 # Allow the package to add exceptions via a hook in cfg.mk;
1178 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1179 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1180 _makefile_at_at_check_exceptions ?=
1181 sc_makefile_at_at_check:
1182 @perl -ne '/\@\w+\@/' \
1183 -e ' && !/(\w+)\s+=.*\@\1\@$$/' \
1184 -e ''$(_makefile_at_at_check_exceptions) \
1185 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1186 $$($(VC_LIST_EXCEPT) | $(GREP) -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1187 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1189 news-check: NEWS
1190 $(AM_V_GEN)if $(SED) -n $(news-check-lines-spec)p $< \
1191 | $(GREP) -E $(news-check-regexp) >/dev/null; then \
1192 :; \
1193 else \
1194 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1195 exit 1; \
1198 sc_makefile_TAB_only_indentation:
1199 @prohibit='^ [ ]{8}' \
1200 in_vc_files='akefile|\.mk$$' \
1201 halt='found TAB-8-space indentation' \
1202 $(_sc_search_regexp)
1204 sc_m4_quote_check:
1205 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1206 in_vc_files='(^configure\.ac|\.m4)$$' \
1207 halt='quote the first arg to AC_DEF*' \
1208 $(_sc_search_regexp)
1210 fix_po_file_diag = \
1211 'you have changed the set of files with translatable diagnostics;\n\
1212 apply the above patch\n'
1214 # Generate a list of files in which to search for translatable strings.
1215 perl_translatable_files_list_ = \
1216 -e 'foreach $$file (@ARGV) {' \
1217 -e ' \# Consider only file extensions with one or two letters' \
1218 -e ' $$file =~ /\...?$$/ or next;' \
1219 -e ' \# Ignore m4 and mk files' \
1220 -e ' $$file =~ /\.m[4k]$$/ and next;' \
1221 -e ' \# Ignore a .c or .h file with a corresponding .l or .y file' \
1222 -e ' $$file =~ /(.+)\.[ch]$$/ && (-e "$${1}.l" || -e "$${1}.y")' \
1223 -e ' and next;' \
1224 -e ' \# Skip unreadable files' \
1225 -e ' -r $$file or next;' \
1226 -e ' print "$$file ";' \
1227 -e '}'
1229 # Verify that all source files using _() (more specifically, files that
1230 # match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
1231 po_file ?= $(srcdir)/po/POTFILES.in
1232 generated_files ?= $(srcdir)/lib/*.[ch]
1233 _gl_translatable_string_re ?= \b(N?_|gettext *)\([^)"]*("|$$)
1234 sc_po_check:
1235 @if test -f $(po_file); then \
1236 $(GREP) -E -v '^(#|$$)' $(po_file) \
1237 | $(GREP) -v '^src/false\.c$$' | sort > $@-1; \
1238 { $(VC_LIST_EXCEPT); echo $(generated_files); } \
1239 | xargs perl $(perl_translatable_files_list_) \
1240 | xargs $(GREP) -E -l '$(_gl_translatable_string_re)' \
1241 | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
1242 | sort -u > $@-2; \
1243 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1244 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1245 rm -f $@-1 $@-2; \
1248 # Sometimes it is useful to change the PATH environment variable
1249 # in Makefiles. When doing so, it's better not to use the Unix-centric
1250 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1251 msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1252 sc_makefile_path_separator_check:
1253 @prohibit='PATH[=].*:' \
1254 in_vc_files='akefile|\.mk$$' \
1255 halt=$(msg) \
1256 $(_sc_search_regexp)
1258 # Check that 'make alpha' will not fail at the end of the process,
1259 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1260 # and is read-only.
1261 writable-files:
1262 $(AM_V_GEN)if test -d $(release_archive_dir); then \
1263 for file in $(DIST_ARCHIVES); do \
1264 for p in ./ $(release_archive_dir)/; do \
1265 test -e $$p$$file || continue; \
1266 test -w $$p$$file \
1267 || { echo ERROR: $$p$$file is not writable; fail=1; }; \
1268 done; \
1269 done; \
1270 test "$$fail" && exit 1 || : ; \
1271 else :; \
1274 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1275 sample-test = tests/sample-test
1276 texi = doc/$(PACKAGE).texi
1277 # Make sure that the copyright date in $(v_etc_file) is up to date.
1278 # Do the same for the $(sample-test) and the main doc/.texi file.
1279 sc_copyright_check:
1280 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1281 in_files=$(v_etc_file) \
1282 halt='out of date copyright in $(v_etc_file); update it' \
1283 $(_sc_search_regexp)
1284 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1285 in_vc_files=$(sample-test) \
1286 halt='out of date copyright in $(sample-test); update it' \
1287 $(_sc_search_regexp)
1288 @require='Copyright @copyright\{\} .*'$$(date +%Y) \
1289 in_vc_files=$(texi) \
1290 halt='out of date copyright in $(texi); update it' \
1291 $(_sc_search_regexp)
1293 # If tests/help-version exists and seems to be new enough, assume that its
1294 # use of init.sh and path_prepend_ is correct, and ensure that every other
1295 # use of init.sh is identical.
1296 # This is useful because help-version cross-checks prog --version
1297 # with $(VERSION), which verifies that its path_prepend_ invocation
1298 # sets PATH correctly. This is an inexpensive way to ensure that
1299 # the other init.sh-using tests also get it right.
1300 _hv_file ?= $(srcdir)/tests/help-version
1301 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1302 # Fix syntax-highlighters "
1303 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1304 sc_cross_check_PATH_usage_in_tests:
1305 @if test -f $(_hv_file); then \
1306 $(GREP) -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1307 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1308 exit 0; }; \
1309 $(GREP) -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1310 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1311 exit 1; }; \
1312 good=$$($(GREP) -E '$(_hv_regex_strong)' $(_hv_file)); \
1313 $(VC_LIST_EXCEPT) \
1314 | xargs $(GREP) -lE '$(_hv_regex_weak)' \
1315 | xargs $(GREP) -LFx "$$good" \
1316 | $(GREP) . \
1317 && { printf "$(ME): the above files use" \
1318 " path_prepend_ inconsistently\n" 1>&2; \
1319 exit 1; } \
1320 || :; \
1323 # BRE regex of file contents to identify a test script.
1324 _test_script_regex ?= \<init\.sh\>
1326 # In tests, use "compare expected actual", not the reverse.
1327 sc_prohibit_reversed_compare_failure:
1328 @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1329 containing='$(_test_script_regex)' \
1330 halt='reversed compare arguments' \
1331 $(_sc_search_regexp)
1333 # #if HAVE_... will evaluate to false for any non numeric string.
1334 # That would be flagged by using -Wundef, however gnulib currently
1335 # tests many undefined macros, and so we can't enable that option.
1336 # So at least preclude common boolean strings as macro values.
1337 sc_Wundef_boolean:
1338 @prohibit='^#define.*(yes|no|true|false)$$' \
1339 in_files='$(CONFIG_INCLUDE)' \
1340 halt='Use 0 or 1 for macro values' \
1341 $(_sc_search_regexp)
1343 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1344 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1345 # a limit, not an array or alloca size.
1346 sc_prohibit_path_max_allocation:
1347 @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX' \
1348 halt='Avoid stack allocations of size PATH_MAX' \
1349 $(_sc_search_regexp)
1351 sc_vulnerable_makefile_CVE-2009-4029:
1352 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1353 in_files='(^|/)Makefile\.in$$' \
1354 halt=$$(printf '%s\n' \
1355 'the above files are vulnerable; beware of running' \
1356 ' "make dist*" rules, and upgrade to fixed automake' \
1357 ' see https://bugzilla.redhat.com/show_bug.cgi?id=542609 for details') \
1358 $(_sc_search_regexp)
1360 sc_vulnerable_makefile_CVE-2012-3386:
1361 @prohibit='chmod a\+w \$$\(distdir\)' \
1362 in_files='(^|/)Makefile\.in$$' \
1363 halt=$$(printf '%s\n' \
1364 'the above files are vulnerable; beware of running' \
1365 ' "make distcheck", and upgrade to fixed automake' \
1366 ' see https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2012-3386 for details') \
1367 $(_sc_search_regexp)
1369 vc-diff-check:
1370 $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1371 $(AM_V_at)if test -s vc-diffs; then \
1372 cat vc-diffs; \
1373 echo "Some files are locally modified:" 1>&2; \
1374 exit 1; \
1375 else \
1376 rm vc-diffs; \
1379 rel-files = $(DIST_ARCHIVES)
1381 gnulib-version = $$(cd $(gnulib_dir) \
1382 && { git describe || git rev-parse --short=10 HEAD; } )
1383 bootstrap-tools ?= autoconf,automake,gnulib
1385 gpgv = $$(gpgv2 --version >/dev/null && echo gpgv2 || echo gpgv)
1386 # If it's not already specified, derive the GPG key ID from
1387 # the signed tag we've just applied to mark this release.
1388 gpg_key_ID ?= \
1389 $$(cd $(srcdir) \
1390 && git cat-file tag v$(VERSION) \
1391 | $(gpgv) --status-fd 1 --keyring /dev/null - - 2>/dev/null \
1392 | $(AWK) '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
1394 translation_project_ ?= coordinator@translationproject.org
1396 # Make info-gnu the default only for a stable release.
1397 announcement_Cc_stable = $(translation_project_), $(PACKAGE_BUGREPORT)
1398 announcement_mail_headers_stable = \
1399 To: info-gnu@gnu.org \
1400 Cc: $(announcement_Cc_) \
1401 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1403 announcement_Cc_alpha = $(translation_project_)
1404 announcement_mail_headers_alpha = \
1405 To: $(PACKAGE_BUGREPORT) \
1406 Cc: $(announcement_Cc_)
1408 announcement_mail_Cc_beta = $(announcement_mail_Cc_alpha)
1409 announcement_mail_headers_beta = $(announcement_mail_headers_alpha)
1411 announcement_mail_Cc_ ?= $(announcement_mail_Cc_$(release-type))
1412 announcement_mail_headers_ ?= $(announcement_mail_headers_$(release-type))
1413 announcement: NEWS ChangeLog $(rel-files)
1414 # Not $(AM_V_GEN) since the output of this command serves as
1415 # announcement message: it would start with " GEN announcement".
1416 $(AM_V_at)$(srcdir)/$(_build-aux)/announce-gen \
1417 --mail-headers='$(announcement_mail_headers_)' \
1418 --release-type=$(release-type) \
1419 --package=$(PACKAGE) \
1420 --prev=$(PREV_VERSION) \
1421 --curr=$(VERSION) \
1422 --gpg-key-id=$(gpg_key_ID) \
1423 --srcdir=$(srcdir) \
1424 --news=$(srcdir)/NEWS \
1425 --bootstrap-tools=$(bootstrap-tools) \
1426 $$(case ,$(bootstrap-tools), in (*,gnulib,*) \
1427 echo --gnulib-version=$(gnulib-version);; esac) \
1428 --no-print-checksums \
1429 $(addprefix --url-dir=, $(url_dir_list))
1431 .PHONY: release-commit
1432 release-commit:
1433 $(AM_V_GEN)cd $(srcdir) \
1434 && $(_build-aux)/do-release-commit-and-tag \
1435 -C $(abs_builddir) $(RELEASE)
1437 ## ---------------- ##
1438 ## Updating files. ##
1439 ## ---------------- ##
1441 ftp-gnu = https://ftp.gnu.org/gnu
1442 www-gnu = https://www.gnu.org
1444 upload_dest_dir_ ?= $(PACKAGE)
1445 upload_command = \
1446 $(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \
1447 --to $(gnu_rel_host):$(upload_dest_dir_) \
1448 $(rel-files)
1449 emit_upload_commands:
1450 @echo =====================================
1451 @echo =====================================
1452 @echo '$(upload_command)'
1453 @echo '# send the ~/announce-$(my_distdir) e-mail'
1454 @echo =====================================
1455 @echo =====================================
1457 .PHONY: upload
1458 upload:
1459 $(AM_V_GEN)$(upload_command)
1461 define emit-commit-log
1462 printf '%s\n' 'maint: post-release administrivia' '' \
1463 '* NEWS: Add header line for next release.' \
1464 '* .prev-version: Record previous version.' \
1465 '* cfg.mk (old_NEWS_hash): Auto-update.'
1466 endef
1468 .PHONY: no-submodule-changes
1469 no-submodule-changes:
1470 $(AM_V_GEN)if test -d $(srcdir)/.git \
1471 && git --version >/dev/null 2>&1; then \
1472 diff=$$(cd $(srcdir) && git submodule -q foreach \
1473 git diff-index --name-only HEAD) \
1474 || exit 1; \
1475 case $$diff in '') ;; \
1476 *) echo '$(ME): submodule files are locally modified:'; \
1477 echo "$$diff"; exit 1;; esac; \
1478 else \
1479 : ; \
1482 submodule-checks ?= no-submodule-changes public-submodule-commit
1484 # Ensure that each sub-module commit we're using is public.
1485 # Without this, it is too easy to tag and release code that
1486 # cannot be built from a fresh clone.
1487 .PHONY: public-submodule-commit
1488 public-submodule-commit:
1489 $(AM_V_GEN)if test -d $(srcdir)/.git \
1490 && git --version >/dev/null 2>&1; then \
1491 cd $(srcdir) && \
1492 git submodule --quiet foreach \
1493 'test "$$(git rev-parse "$$sha1")" \
1494 = "$$(git merge-base origin "$$sha1")"' \
1495 || { echo '$(ME): found non-public submodule commit' >&2; \
1496 exit 1; }; \
1497 else \
1498 : ; \
1500 # This rule has a high enough utility/cost ratio that it should be a
1501 # dependent of "check" by default. However, some of us do occasionally
1502 # commit a temporary change that deliberately points to a non-public
1503 # submodule commit, and want to be able to use rules like "make check".
1504 # In that case, run e.g., "make check gl_public_submodule_commit="
1505 # to disable this test.
1506 gl_public_submodule_commit ?= public-submodule-commit
1507 check: $(gl_public_submodule_commit)
1509 .PHONY: alpha beta stable release
1510 ALL_RECURSIVE_TARGETS += alpha beta stable
1511 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1512 $(AM_V_GEN)test $@ = stable \
1513 && { echo $(VERSION) | $(GREP) -E '^[0-9]+(\.[0-9]+)+$$' \
1514 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1515 || :
1516 $(AM_V_at)$(MAKE) vc-diff-check
1517 $(AM_V_at)$(MAKE) news-check
1518 $(AM_V_at)$(MAKE) distcheck
1519 $(AM_V_at)$(MAKE) dist
1520 $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1521 $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1523 release:
1524 $(AM_V_GEN)$(MAKE) _version
1525 $(AM_V_GEN)$(MAKE) $(release-type)
1527 # Override this in cfg.mk if you follow different procedures.
1528 release-prep-hook ?= release-prep
1530 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1531 .PHONY: release-prep
1532 release-prep:
1533 $(AM_V_GEN)$(MAKE) --no-print-directory -s announcement \
1534 > ~/announce-$(my_distdir)
1535 $(AM_V_at)if test -d $(release_archive_dir); then \
1536 ln $(rel-files) $(release_archive_dir); \
1537 chmod a-w $(rel-files); \
1539 $(AM_V_at)echo $(VERSION) > $(prev_version_file)
1540 $(AM_V_at)$(MAKE) update-NEWS-hash
1541 $(AM_V_at)perl -pi \
1542 -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' \
1543 $(srcdir)/NEWS
1544 $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1; \
1545 cd $(srcdir) && $(VC) commit -m "$$msg" -a
1547 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1548 # if the default $(PACKAGE)-derived name doesn't apply.
1549 gendocs_options_ ?=
1551 .PHONY: web-manual
1552 web-manual:
1553 $(AM_V_GEN)test -z "$(manual_title)" \
1554 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1555 $(AM_V_at)cd '$(srcdir)/doc'; \
1556 $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1557 -o '$(abs_builddir)/doc/manual' \
1558 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1559 "$(PACKAGE_NAME) - $(manual_title)"
1560 $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
1562 .PHONY: web-manual-update
1563 web-manual-update:
1564 $(AM_V_GEN)cd $(srcdir) \
1565 && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
1568 # Code Coverage
1570 init-coverage:
1571 $(MAKE) $(AM_MAKEFLAGS) clean
1572 lcov --directory . --zerocounters
1574 COVERAGE_CCOPTS ?= "-g --coverage"
1575 COVERAGE_OUT ?= doc/coverage
1577 build-coverage:
1578 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1579 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1580 mkdir -p $(COVERAGE_OUT)
1581 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1582 --capture
1584 gen-coverage:
1585 genhtml --output-directory $(COVERAGE_OUT) \
1586 $(COVERAGE_OUT)/$(PACKAGE).info \
1587 --highlight --frames --legend \
1588 --title "$(PACKAGE_NAME)"
1590 coverage:
1591 $(MAKE) init-coverage
1592 $(MAKE) build-coverage
1593 $(MAKE) gen-coverage
1595 # Some projects carry local adjustments for gnulib modules via patches in
1596 # a gnulib patch directory whose default name is gl/ (defined in bootstrap
1597 # via local_gl_dir=gl). Those patches become stale as the originals evolve
1598 # in gnulib. Use this rule to refresh any stale patches. It applies each
1599 # patch to the original in $(gnulib_dir) and uses the temporary result to
1600 # generate a fuzz-free .diff file. If you customize the name of your local
1601 # gnulib patch directory via bootstrap.conf, this rule detects that name.
1602 # Run this from a non-VPATH (i.e., srcdir) build directory.
1603 .PHONY: refresh-gnulib-patches
1604 refresh-gnulib-patches:
1605 gl=gl; \
1606 if test -f bootstrap.conf; then \
1607 t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;' \
1608 -e 'END{defined $$d and print $$d}' bootstrap.conf); \
1609 test -n "$$t" && gl=$$t; \
1610 fi; \
1611 for diff in $$(cd $$gl; git ls-files | $(GREP) '\.diff$$'); do \
1612 b=$$(printf %s "$$diff"|$(SED) 's/\.diff$$//'); \
1613 VERSION_CONTROL=none \
1614 patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1; \
1615 ( cd $(gnulib_dir) || exit 1; \
1616 git diff "$$b" > "../$$gl/$$diff"; \
1617 git checkout $$b ) || exit 1; \
1618 done
1620 # Update gettext files.
1621 PACKAGE ?= $(shell basename $(PWD))
1622 PO_DOMAIN ?= $(PACKAGE)
1623 POURL = https://translationproject.org/latest/$(PO_DOMAIN)/
1624 PODIR ?= po
1625 refresh-po:
1626 rm -f $(PODIR)/*.po && \
1627 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1628 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1629 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1630 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1631 ls $(PODIR)/*.po | $(SED) 's/\.po//;s,$(PODIR)/,,' | \
1632 sort >> $(PODIR)/LINGUAS
1634 # Running indent once is not idempotent, but running it twice is.
1635 INDENT_SOURCES ?= $(C_SOURCES)
1636 .PHONY: indent
1637 indent:
1638 indent $(INDENT_SOURCES)
1639 indent $(INDENT_SOURCES)
1641 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1642 # put the assignments in this variable.
1643 update-copyright-env ?=
1645 # Run this rule once per year (usually early in January)
1646 # to update all FSF copyright year lists in your project.
1647 # If you have an additional project-specific rule,
1648 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1649 # By default, exclude all variants of COPYING; you can also
1650 # add exemptions (such as ChangeLog..* for rotated change logs)
1651 # in the file .x-update-copyright.
1652 .PHONY: update-copyright
1653 update-copyright:
1654 $(AM_V_GEN)$(GREP) -l -w Copyright \
1655 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1656 | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1658 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1659 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1661 # NOTE: to override any _gl_TS_* default value, you must
1662 # define the variable(s) using "export" in cfg.mk.
1663 _gl_TS_dir ?= src
1665 ALL_RECURSIVE_TARGETS += sc_tight_scope
1666 sc_tight_scope: tight-scope.mk
1667 @fail=0; \
1668 if ! $(GREP) '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1669 > /dev/null \
1670 && ! $(GREP) -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1671 > /dev/null 2>&1; then \
1672 echo '$(ME): skipping $@'; \
1673 else \
1674 $(MAKE) -s -C $(_gl_TS_dir) \
1675 -f Makefile \
1676 -f $(abs_top_srcdir)/cfg.mk \
1677 -f $(abs_top_builddir)/$< \
1678 _gl_tight_scope \
1679 || fail=1; \
1680 fi; \
1681 rm -f $<; \
1682 exit $$fail
1684 tight-scope.mk: $(ME)
1685 @rm -f $@ $@-t
1686 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1687 @chmod a=r $@-t && mv $@-t $@
1689 ifeq (a,b)
1690 # TS-start
1692 # Most functions should have static scope.
1693 # Any that don't must be marked with 'extern', but 'main'
1694 # and 'usage' are exceptions: they're always extern, but
1695 # do not need to be marked. Symbols matching '__.*' are
1696 # reserved by the compiler, so are automatically excluded below.
1697 _gl_TS_unmarked_extern_functions ?= main usage
1698 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\w+) *\(/
1700 # If your project uses a macro like "XTERN", then put
1701 # the following in cfg.mk to override this default:
1702 # export _gl_TS_extern = extern|XTERN
1703 _gl_TS_extern ?= extern
1705 # The second nm|grep checks for file-scope variables with 'extern' scope.
1706 # Without gnulib's progname module, you might put program_name here.
1707 # Symbols matching '__.*' are reserved by the compiler,
1708 # so are automatically excluded below.
1709 _gl_TS_unmarked_extern_vars ?=
1711 # NOTE: the _match variables are perl expressions -- not mere regular
1712 # expressions -- so that you can extend them to match other patterns
1713 # and easily extract matched variable names.
1714 # For example, if your project declares some global variables via
1715 # a macro like this: GLOBAL(type, var_name, initializer), then you
1716 # can override this definition to automatically extract those names:
1717 # export _gl_TS_var_match = \
1718 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1719 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1721 # The names of object files in (or relative to) $(_gl_TS_dir).
1722 _gl_TS_obj_files ?= *.$(OBJEXT)
1724 # Files in which to search for the one-line style extern declarations.
1725 # $(_gl_TS_dir)-relative.
1726 _gl_TS_headers ?= $(noinst_HEADERS)
1727 _gl_TS_other_headers ?= *.h
1729 .PHONY: _gl_tight_scope
1730 _gl_tight_scope: $(bin_PROGRAMS)
1731 sed_wrap='s/^/^_?/;s/$$/$$/'; \
1732 t=exceptions-$$$$; \
1733 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1734 for sig in 1 2 3 13 15; do \
1735 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1736 done; \
1737 src=`for f in $(SOURCES); do \
1738 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1739 hdr=`for f in $(_gl_TS_headers); do \
1740 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1741 ( printf '%s\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1742 $(GREP) -h -A1 '^extern .*[^;]$$' $$src \
1743 | $(GREP) -vE '^(extern |--|#)' | $(SED) 's/ .*//; /^$$/d'; \
1744 perl -lne \
1745 '$(_gl_TS_function_match) and print $$1' $$hdr; \
1746 ) | sort -u | $(SED) "$$sed_wrap" > $$t; \
1747 nm -g $(_gl_TS_obj_files)|$(SED) -n 's/.* T //p'|$(GREP) -Ev -f $$t \
1748 && { echo the above functions should have static scope >&2; \
1749 exit 1; } || : ; \
1750 ( printf '%s\n' '__.*' main $(_gl_TS_unmarked_extern_vars); \
1751 perl -lne '$(_gl_TS_var_match) and print $$1' \
1752 $$hdr $(_gl_TS_other_headers) \
1753 ) | sort -u | $(SED) "$$sed_wrap" > $$t; \
1754 nm -g $(_gl_TS_obj_files) | $(SED) -n 's/.* [BCDGRS] //p' \
1755 | sort -u | $(GREP) -Ev -f $$t \
1756 && { echo the above variables should have static scope >&2; \
1757 exit 1; } || :
1758 # TS-end
1759 endif